#include <iostream>
#include <bezier.hpp>
#include <sndfile.hpp>
#include <wav.h>
using namespace std;
using namespace doj;
#include "sil.c"
int main(int argc, char **argv)
{
  if(argc!=2)
    {
      cerr << "usage: wavshaper <filename>\n";
      return 1;
    }

  int samplerate, channels; unsigned size;
  float *smp;
  smp=sndfile_read(argv[1], samplerate, channels, size, smp);
  if(!smp)
    return 1;
  if(channels!=1)
    {
      cerr << "can only work with mono samples\n";
      return 1;
    }
  if(!size)
    {
      cerr << argv[1] << " is empty\n";
      return 1;
    }

  const unsigned silsize=sizeof(siluette)/sizeof(siluette[0]);
  Bezier<double> b;
  for(unsigned i=0; i!=silsize; ++i)
    b.push_back(siluette[i]);

  for(unsigned i=0; i!=size; ++i)
    smp[i]*=b(static_cast<double>(i)/static_cast<double>(size));

  return -WAVsave("out.wav", channels, samplerate, smp, smp+size);
}
